////////////////////////////////////////////////////////////////////////////////
//
//	Russell Osterlund, May 2001
//
//	Pseudocode for:
//		LdrpCheckForLoadedDll
//
////////////////////////////////////////////////////////////////////////////////
#include "LdrpLoadDll.h"

////////////////////////////////////////////////////////////////////////////////
// return	1, if loaded
//			0, if not loaded
BYTE
	LdrpCheckForLoadedDll
		(LPCWSTR SearchPath,
		PUNICODE_STRING DllName,
		ULONG UseLdrpHashTable,	// equals 0 when called by LdrpLoadDll
								// equals 1 when called by LdrpUpdateLoadCount
								//   and LdrpWalkImportDescriptor
		ULONG ReturnCode,
		PMODULEITEM pModuleItem)
{
	ULONG WorkPathAddr;			// ebp-0x20
	ULONG DosSearchPathResult;	// ebp-0x24
	UCHAR PathIncluded;			// ebp-0x2c
	LPCWSTR WorkPath;			// ebp-0x24c

	// This routine is wrapped by a __try/__except block.
	if ((NULL == DllName->Buffer)
			||
		(0 == DllName->Buffer[0]))
		return 0;
SearchHashTable:
	if (UseLdrpHashTable)
	{
		BYTE c =
			RtlUpcaseUnicodeChar
				(DllName->Buffer[0]);
		c--;
		c &= 0x1F;
		// See discussion found in LdrpInsertMemoryTableEntry.
		if (/* If the entry found at LdrpHashTable + (c * sizeof (LIST_ENTRY)) is not occupied, then */)
			if (UseLdrpHashTable)
				return 0;
			else
				goto SearchThePEB;
		do
		{
			if (/* This entry is the same as the DllName. */)
			{
				// pModuleItem = the entry
				return 1;
			}
		} while (/* There are additional entries in this slot. */);
		if (UseLdrpHashTable)
			return 0;
		else
			goto SearchThePEB;
	}
	else
	{
SearchThePEB:
		PMODULEITEM pSearchItem;
		PathIncluded &= 0;
		if ((NULL == wcschr (DllName, '/'))
				&&
			(NULL == wcschr (DllName, '\\')))
		{
			// Search the module load list by FileName.
			if (Found)
			{
				// If the found module is not loaded, load it.
				// pModuleItem = the found item
				return 1;
			}
		}
		else
		{
			PathIncluded = 1;
			WorkPathAddr = &WorkPath;
			WorkPath = SearchPath;
			if (NULL == SearchPath)
				WorkPath = LdrpDefaultPath + 4;	// contains pointer to the process' search path
			DosSearchPathResult =
				RtlDosSearchPath_U
					(WorkPath,
					DllName,
					0,
					MAX_DLL_NAME_LENGTH - sizeof (WCHAR),
					WorkPath, 				// output
					NULL);					// output
			if ((0 == DosSearchPathResult)
					||
				(MAX_DLL_NAME_LENGTH - sizeof (WCHAR) < DosSearchPathResult))
			{
				if (ShowSnaps)
					DbgPrint
						("LDR: LdrpCheckForLoadedDll - Unable to locate %ws from %ws",
						DllName,
						WorkPath);
				return 0;
			}
			// Search the module load list by PathFileName with results from RtlDosSearchPath_U.
			if (Found)
			{
				// If the found module is not loaded, load it.
				// pModuleItem = the found item
				return 1;
			}
		}
		UseLdrpHashTable = 1;
		goto SearchHashTable;
	}
	return 0;
} // LdrpCheckForLoadedDll