////////////////////////////////////////////////////////////////////////////////
//
//	Russell Osterlund, May 2001
//
////////////////////////////////////////////////////////////////////////////////
#define MAX_DLL_NAME_LENGTH	0x214

// used with ModuleFlags
#define STATIC_LINK				0x00000002
#define IMAGE_DLL				0x00000004
#define LOAD_IN_PROGRESS		0x00001000
#define UNLOAD_IN_PROGRESS		0x00002000
#define ENTRY_PROCESSED			0x00004000
#define ENTRY_INSERTED			0x00008000
#define CURRENT_LOAD			0x00010000
#define FAILED_BUILTIN_LOAD		0x00020000
#define DONT_CALL_FOR_THREAD	0x00040000
#define PROCESS_ATTACH_CALLED	0x00080000
#define DEBUG_SYMBOLS_LOADED	0x00100000
#define IMAGE_NOT_AT_BASE		0x00200000
#define WX86_IGNORE_MACHINETYPE	0x00400000

typedef struct tagMODULELISTLINKS
{
	PMODULEITEM Next;
	PMODULEITEM Prev;
} MODULELISTLINKS, *PMODULELISTLINKS;

typedef struct tagMODULEITEM		// offset
{
	MODULELISTLINKS LoadOrder;		// 0x00
	MODULELISTLINKS MemOrder;		// 0x08
	MODULELISTLINKS InitOrder;		// 0x10
	ULONG ImageBase;				// 0x18
	ULONG EntryPoint;				// 0x1C
	ULONG ImageSize;				// 0x20
	UNICODE_STRING PathFileName;	// 0x24
	UNICODE_STRING FileName;		// 0x2C
	ULONG ModuleFlags;				// 0x34
	SHORT LoadCount;				// 0x38
	WORD Fill;						// 0x3A
	ULONG Unknown1;					// 0x3C
	ULONG Unknown2;					// 0x40
	ULONG TimeDateStamp;			// 0x44
} MODULEITEM, *PMODULEITEM;			// 0x48 bytes

typedef struct tagMODULELISTHEADER
{
	ULONG HeaderSize;
	ULONG Unknown[2];
	MODULELISTLINKS LoadOrder;
	MODULELISTLINKS MemOrder;
	MODULELISTLINKS InitOrder;
} MODULELISTHEADER, *PMODULELISTHEADER;

typedef struct tagHINT_NAME_ENTRY
{
	USHORT Hint;
	LPSTR Name;
} HINT_NAME_ENTRY, *PHINT_NAME_ENTRY;
