////////////////////////////////////////////////////////////////////////////////
//
//	Russell Osterlund, May 2001
//
//	Pseudocode for:
//		LdrpUpdateLoadCount
//
////////////////////////////////////////////////////////////////////////////////
#include "LdrpLoadDll.h"

////////////////////////////////////////////////////////////////////////////////
void
	LdrpUpdateLoadCount
		(PMODULEITEM pModuleItem,
		ULONG Loading)
{
	PUNICODE_STRING TEBWorkString = TEB + 0xBF8;				// ebp-0x4
	ULONG BoundImportDirectoryDataSize;							// ebp-0xC
	PIMAGE_BOUND_IMPORT_DESCRIPTOR pImageBoundImportDescriptor;	// ebp-0x10
	ULONG ImportDirectoryDataSize;								// ebp-0x14
	PANSI_STRING pBoundImportAnsiString;						// ebp-0x18
	PANSI_STRING pImportAnsiString;								// ebp-0x1C
	if (Loading)
		pModuleItem->ModuleFlags |= LOAD_IN_PROGRESS;
	else
	if ((!Loading)
			&&
		(UNLOAD_IN_PROGRESS == pModuleItem->ModuleFlags))
		pModuleItem->ModuleFlags |= UNLOAD_IN_PROGRESS;
	else
		return;
	pImageBoundImportDescriptor = 
		(PIMAGE_BOUND_IMPORT_DESCRIPTOR) RtlImageDirectoryEntryToData
			(pModuleItem->ImageBase,
			1,
			IMAGE_DIRECTORY_ENTRY_BOUND_IMPORT,
			&BoundImportDirectoryDataSize);
	if (pImageBoundImportDescriptor)
	{
		if (Loading)
			pModuleItem->ModuleFlags |= LOAD_IN_PROGRESS;
		else
			pModuleItem->ModuleFlags |= UNLOAD_IN_PROGRESS;
		while (pImageBoundImportDescriptor->OffsetModuleName)
		{
			RtlInitAnsiString
				(pBoundImportAnsiString,
				pImageBoundImportDescriptor->OffsetModuleName);
			if (RtlAnsiStringToUnicodeString
					(TEBWorkString,
					pBoundImportAnsiString,
					FALSE))
				if (LdrpCheckForLoadedDll
						(NULL,
						TEBWorkString,
						1,
						0,
						pModuleItem))
				{
					if (pModuleItem->LoadCount != -1)
					{
						if (Loading)
						{
							pModuleItem->LoadCount++;
							if (ShowSnaps)
								DbgPrint
									("LDR: Refcount   %wZ (%lx)",
									TEBWorkString,
									pModuleItem->LoadCount);
						}
						else
						{
							pModuleItem->LoadCount--;
							if (ShowSnaps)
								DbgPrint
									("LDR: Derefcount   %wZ (%lx)",
									TEBWorkString,
									pModuleItem->LoadCount);
						}
					}
					LdrpUpdateLoadCount
						(pModuleItem,
						Loading);
				}
			pImageBoundImportDescriptor += sizeof (IMAGE_BOUND_IMPORT_DESCRIPTOR);
		}
	}
	else
	{
		PIMAGE_IMPORT_DESCRIPTOR pImageImportDescriptor =
			(PIMAGE_IMPORT_DESCRIPTOR) RtlImageDirectoryEntryToData
				(pModuleItem->ImageBase,
				1,
				IMAGE_DIRECTORY_ENTRY_IMPORT,
				&ImportDirectoryDataSize);
		while (pImageImportDescriptor)
		{
			if (0 == pImageImportDescriptor->Name)
				return;
			if (0 == pImageImportDescriptor->FirstThunk)
				return;
			if (0 == pImageImportDescriptor->OriginalFirstThunk)
				return;
			RtlInitAnsiString
				(pImportAnsiString,
				pImageImportDescriptor->Name);
			if (RtlAnsiStringToUnicodeString
					(TEBWorkString,
					pImportAnsiString,
					FALSE))
				if (LdrpCheckForLoadedDll
						(NULL,
						TEBWorkString,
						1,
						0,
						pModuleItem))
				{
					if (pModuleItem->LoadCount != -1)
					{
						if (Loading)
						{
							pModuleItem->LoadCount++;
							if (ShowSnaps)
								DbgPrint
									("LDR: Refcount   %wZ (%lx)",
									TEBWorkString,
									pModuleItem->LoadCount);
						}
						else
						{
							pModuleItem->LoadCount--;
							if (ShowSnaps)
								DbgPrint
									("LDR: Derefcount   %wZ (%lx)",
									TEBWorkString,
									pModuleItem->LoadCount);
						}
					}
					LdrpUpdateLoadCount
						(pModuleItem,
						Loading);
				}
			pImageImportDescriptor += sizeof (IMAGE_IMPORT_DESCRIPTOR);
		}
	}
} // LdrpUpdateLoadCount